; __________________________________________________________________________________________________
;|********************                La classe object Ldroite                **********************|
;|__________________________________________________________________________________________________|
(define (Ldroite%)
  (define (Translation_gauche? L table sens?)
    (case sens?
      ((1) (and (not (zero? (caar (cdddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))))
      ((2) (and (not (zero? (caar L)))
                (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))))
      ((3) (and (not (zero? (caar L)))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L))))))
      ((4) (and (not (zero? (caadr L)))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))))
      (else error "pas possible")))
  (define (Translation_droite? L table sens?)
    (case sens?
      ((1) (and (not (= (caar L) 10))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L))))))
      ((2) (and (not (= (caar L) 9))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))))
      ((3) (and (not (equal? (caar (cdddr L)) 10))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))))
      ((4) (and (not (= (caar L) 10))
                (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))))
      (else error "pas possible")))
  (define (Rotation_Ldroite? L table sens?)
    (case sens?
      ((1) (and (not (or (= (caadr L) 10) (< (cadadr L) 1)))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1)))
                (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 2)))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (caadr L)))))
      ((2) (and (not (= (caadr L) 10))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (caadr L)))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (caadr L)))
                (not (vector-ref (vector-ref table (- (cadadr L) 2)) (caadr L)))))
      ((3) (and (not (= (caadr L) 0))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (caadr L)))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (cadadr L)) (+ (caadr L) 2)))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (sub1 (caadr L))))))
      ((4) (and (not (or (= (caadr L) 0) (< (cadadr L) 1)))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (caadr L)))
                (not (vector-ref (vector-ref table (sub1 (cadadr L))) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (caadr L)))
                (not (vector-ref (vector-ref table (add1 (cadadr L))) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (+ (cadadr L) 2)) (caadr L)))))))
  (define (Evaluer_Ldroite_sens1 L)
    (cons (list (caar L) (cadar L))
          (cons (list (caar L) (sub1 (cadar L)))
                (cons (list (sub1 (caar L)) (cadar L))
                      (cons (list (- (caar L) 2) (cadar L)) '())))))
  (define (Evaluer_Ldroite_sens2 L)
    (cons (list (caar L) (cadar L))
          (cons (list (add1 (caar L)) (cadar L))
                (cons (list (caar L) (sub1 (cadar L)))
                      (cons (list (caar L) (- (cadar L) 2)) '())))))
  (define (Evaluer_Ldroite_sens3 L)
    (cons (list (caar L) (cadar L))
          (cons (list (caar L) (add1 (cadar L)))
                (cons (list (add1 (caar L)) (cadar L))
                      (cons (list (+ (caar L) 2) (cadar L)) '())))))
  (define (Evaluer_Ldroite_sens4 L)
    (cons (list (caar L) (cadar L))
          (cons (list (sub1 (caar L)) (cadar L))
                (cons (list (caar L) (add1 (cadar L)))
                      (cons (list (caar L) (+ (cadar L) 2)) '())))))
  (define (Descendre_Ldroite? L table sens?)
    (case sens?
      ((1) (and (not (zero? (cadadr L)))
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
                (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))
                (not (vector-ref (vector-ref table (- (cadar (cddr L)) 1)) (caaddr L)))))
      ((2) (and (not (zero? (cadar (cdddr L))))
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
                (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))))
      ((3) (and (not (zero? (cadar L)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))
                (not (vector-ref (vector-ref table (- (cadar (cddr L)) 1)) (caaddr L)))))
      ((4) (and (not (zero? (cadadr L)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))))
      (else error "pas possible")))
  (let ((L '((6 16) (6 15) (5 16) (4 16)))
        (sens 1))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((init) (set! L '((6 16) (6 15) (5 16) (4 16))))
        ((fin) (not (descendre_Ldroite? L (car args) sens)))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Translation_Gauche) (if (Translation_Gauche? L (car args) sens)
                                  (set! L (subtract1_colonne L))
                                  (void)))
        ((Translation_Droite) (if (Translation_Droite? L (car args) sens)
                                  (set! L (add1_colonne L))
                                  (void)))
        ((Rotation)  (if (Rotation_Ldroite? L (car args) sens)
                         (case sens
                           ((1) (begin
                                  (set! L (Evaluer_Ldroite_sens2 L))
                                  (set! sens 2)))
                           ((2) (begin
                                  (set! L (Evaluer_Ldroite_sens3 L))
                                  (set! sens 3)))
                           ((3) (begin
                                  (set! L (Evaluer_Ldroite_sens4 L))
                                  (set! sens 4)))
                           ((4) (begin
                                  (set! L (Evaluer_Ldroite_sens1 L))
                                  (set! sens 1)))
                           (else error "pas possible"))
                         (void)))
         ((Descendre) (if (descendre_Ldroite? L (car args) sens)
                          (set! L (subtract1_ligne L))
                          (void)))
        (else (error " message inconnu " selecteur))))
  this))