; __________________________________________________________________________________________________
;|********************                La classe object tdroite                **********************|
;|__________________________________________________________________________________________________|
(define (tdroite%)
  (define (Translation_Gauche? L table verti?)
    (if (not verti?)
        (and (not (equal? (caar L) 0))
             (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
             (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1))))
        (and (not (< (caar L) 2))
             (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
             (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1)))
             (not (vector-ref (vector-ref table (cadr (cadddr L))) (- (car (cadddr L)) 1))))))
  (define (Translation_Droite? L table verti?)
    (if (not verti?)
        (and (not (equal? (caar (cdddr L)) 10))
             (not (vector-ref (vector-ref table (car (cdaddr L))) (+ (caaddr L) 1)))
             (not (vector-ref (vector-ref table (cadr (cadddr L))) (+ (car (cadddr L)) 1))))
        (and (not (equal? (caar L) 10))
             (not (vector-ref (vector-ref table (cadar L)) (+ (caar L) 1)))
             (not (vector-ref (vector-ref table (car (cdaddr L))) (+ (caaddr L) 1)))
             (not (vector-ref (vector-ref table (cadr (cadddr L))) (+ (car (cadddr L)) 1))))))
  (define (Rotation_Tdroite? L table verti?)
    (if verti?
        (and (not (= (caar L) 10))
             (not (vector-ref (vector-ref table (+ (cadar L) 2)) (caar L)))
             (not (vector-ref (vector-ref table (+ (cadar L) 2)) (+ (caar L) 1))))
        (and (not (vector-ref (vector-ref table (+ (cadar L) 2)) (caar L)))
             (not (vector-ref (vector-ref table (+ (cadar L) 1)) (caar L))))))
  (define (Evaluer_Tdroite_Horizontal L)
    (cons (list (- (caar L) 1) (cadar L))
          (cons (list (caar L) (+ (cadar L) 1))
                (cons (list (caar L) (cadar L))
                      (cons (list (+ (caar L) 1) (+ (cadar L) 1)) '())))))
  (define (Evaluer_Tdroite_Vertical L)
    (cons (list (caaddr L) (cadr (caddr L)))
          (cons (list (- (caadr L) 1) (cadadr L))
                (cons (list (caadr L) (cadadr L))
                      (cons (list (caar L) (+ (cadar L) 2)) '())))))
  (define (Descendre_Tdroite? L table verti?)
    (if (not verti?)
        (and (not (zero? (cadar L)))
             (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
             (not (vector-ref (vector-ref table (- (cadr (cadddr L)) 1)) (caar (cdddr L))))
             (not (vector-ref (vector-ref table (- (car (cdaddr L)) 1)) (caaddr L))))
        (and (not (zero? (cadar L)))
             (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
             (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L))))))
  (let ((L '((4 15) (5 16) (5 15) (6 16)))
        (verti false))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((init) (set! L '((4 15) (5 16) (5 15) (6 16))))
        ((fin) (not (descendre_Tdroite? L (car args) verti)))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Translation_Gauche) (if (Translation_Gauche? L (car args) verti)
                                  (set! L (subtract1_colonne L))
                                  (void)))
        ((Translation_Droite) (if (Translation_Droite? L (car args) verti)
                                  (set! L (add1_colonne L))
                                  (void)))
        ((Rotation) (if (Rotation_Tdroite? L (car args) verti)
                        (if verti
                            (begin
                              (set! L (Evaluer_Tdroite_Horizontal L))
                              (set! verti false))
                            (begin
                              (set! L (Evaluer_Tdroite_Vertical L))
                              (set! verti true)))
                        (void)))
        ((Descendre) (if (descendre_tdroite? L (car args) verti)
                         (set! L (subtract1_ligne L))
                         (void)))
        (else (error " message inconnu " selecteur))))
    this))