; _____________________________________________________________________________________________________
;|*******************           Modification sur les objets           *********************************|
;|_____________________________________________________________________________________________________|
(define (demande_objet2)
  (case (car attente2)
    ((0) (barre%))
    ((1) (cube%))
    ((2) (tdroite%))
    ((3) (tgauche%))
    ((4) (triangle%))
    ((5) (lgauche%))
    ((6) (ldroite%))
    (else (error " mauvaise vision " (car attente2)))))

; _____________________________________________________________________________________________________
;|*******************             Execution d'une touche              *********************************|
;|_____________________________________________________________________________________________________|
(define (execution_touches_2pl obj1 obj2 Mvt table1 dc1 table2 dc2)
  (case Mvt
    ((up) (begin
            (effacer (obj1 'liste) Table1)
            (obj1 'rotation Table1)
            (ecrire (obj1 'liste) Table1)
            (affiche_tetris dc1 Table1)))
    ((right) (begin
               (effacer (obj1 'liste) Table1)
               (obj1 'translation_droite Table1)
               (ecrire (obj1 'liste) Table1)
               (affiche_tetris dc1 Table1)))
    ((down) (begin
              (if (obj1 'fin Table1)
                  (void)
                  (begin
                    (effacer (obj1 'liste) Table1)
                    (obj1 'Descendre Table1)
                    (ecrire (obj1 'liste) Table1)
                    (affiche_tetris dc1 Table1)))))
    ((left) (begin
              (effacer (obj1 'liste) Table1)
              (obj1 'translation_gauche Table1)
              (ecrire (obj1 'liste) Table1)
              (affiche_tetris dc1 Table1)))
    ((#\z) (begin
            (effacer (obj2 'liste) Table2)
            (obj2 'rotation Table2)
            (ecrire (obj2 'liste) Table2)
            (affiche_tetris dc2 Table2)))
    ((#\d) (begin
               (effacer (obj2 'liste) Table2)
               (obj2 'translation_droite Table2)
               (ecrire (obj2 'liste) Table2)
               (affiche_tetris dc2 Table2)))
    ((#\s) (begin
              (if (obj2 'fin Table2)
                  (void)
                  (begin
                    (effacer (obj2 'liste) Table2)
                    (obj2 'Descendre Table2)
                    (ecrire (obj2 'liste) Table2)
                    (affiche_tetris dc2 Table2)))))
    ((#\q) (begin
              (effacer (obj2 'liste) Table2)
              (obj2 'translation_gauche Table2)
              (ecrire (obj2 'liste) Table2)
              (affiche_tetris dc2 Table2)))
    (else (void))))
; _____________________________________________________________________________________________________
;|*******************             Execution du jeu 2 players          *********************************|
;|_____________________________________________________________________________________________________|
(define (Lancer_2Player dc_vision1 dc1 table1 dc_vision2 dc2 table2)
  (define (finir obj1 obj2 n)
    (send touche set-key-code #\null)
    (if (and (> n 5) (not (obj1 'fin table1 1)) (not (obj1 'fin table1 1)))
        (begin
          (execution_touches_2pl obj1 obj2 'down table1 dc1 table2 dc2)
          (execution_touches_2pl obj1 obj2 '#\s table1 dc1 table2 dc2)
          (finir obj1 obj2 0))
        (begin
          (sleep/yield vitesse2)
          (let ((tuch (send touche get-key-code)))
            (cond ((and (or (> n 3) (equal? tuch 'down)) (obj2 'fin table2 2))
                   (begin
                     (obj2 'init 2)
                     (Simplifier_2player table2 2 table1 obj2 obj1)
                     (Mettre_dans_vision_2p_2 dc_vision2)
                     (if (fin_tetris? table2)
                         (begin
                           (send dc2 draw-bitmap bitmap_Game_over 89 205)
                           (send dc1 draw-bitmap bitmap_winner 89 205))
                         (let ((nv-obj (demande_objet2)))
                           (if (nv-obj 'fin table2)
                               (begin
                                 (send dc2 draw-bitmap bitmap_Game_over 89 205)
                                 (send dc1 draw-bitmap bitmap_winner 89 205))
                               (finir obj1 nv-obj (add1 n)))))))
                  ((and (or (> n 3) (equal? tuch '#\s)) (obj1 'fin table1 1))
                   (begin
                     (obj1 'init 1)
                     (Simplifier_2player table1 1 table2 obj1 obj2)
                     (Mettre_dans_vision_2p_1 dc_vision1)
                     (if (fin_tetris? table1)
                         (begin
                           (send dc1 draw-bitmap bitmap_Game_over 89 205)
                           (send dc2 draw-bitmap bitmap_winner 89 205))
                         (let ((nv-obj (demande_objet1)))
                           (if (nv-obj 'fin table1)
                               (begin
                                 (send dc1 draw-bitmap bitmap_Game_over 89 205)
                                 (send dc2 draw-bitmap bitmap_winner 89 205))
                               (finir nv-obj obj2 (add1 n)))))))
                  (else (begin
                          (execution_touches_2pl obj1 obj2 tuch table1 dc1 table2 dc2)
                          (finir obj1 obj2 (add1 n)))))))))
  (Mettre_dans_vision_2p_1 dc_vision1)
  (Mettre_dans_vision_2p_2 dc_vision2)
  (finir (demande_objet1) (demande_objet2) 0))
