(define player_configue 1)

(define touche_symbol_rotation_joueur1 'up)
(define touche_symbol_gauche_joueur1 'left)
(define touche_symbol_droite_joueur1 'right)
(define touche_symbol_descendre_joueur1 'down)

(define touche_symbol_rotation_joueur2 'z)
(define touche_symbol_gauche_joueur2 'q)
(define touche_symbol_droite_joueur2 'd)
(define touche_symbol_descendre_joueur2 's)

(define touche_configue (make-object key-event%))

(define configuration (make-object frame% "Configuration" #f 280 180 120 270 '(no-resize-border no-system-menu)))

(define panel_configue (make-object vertical-panel% configuration '(border)))

;************** pour les boutons
(define panel_configue_joueurs (make-object horizontal-panel% panel_configue ))
(define panel_gauche_joueur1 (make-object horizontal-panel% panel_configue_joueurs ))
(define panel_droite_joueur2 (make-object horizontal-panel% panel_configue_joueurs ))
(define bouton_player1_configue (make-object button% "Joueur 1" panel_gauche_joueur1
                                  (lambda (button event) 
                                    (if (= player_configue 2)
                                        (begin
                                          (send player_message_configue set-label "Joueur 1")
                                          (set! player_configue 1)
                                          (send dialog_rotation set-value (symbol->string touche_symbol_rotation_joueur1))
                                          (send dialog_gauche set-value (symbol->string touche_symbol_gauche_joueur1))
                                          (send dialog_droite set-value (symbol->string touche_symbol_droite_joueur1))
                                          (send dialog_descendre set-value (symbol->string touche_symbol_descendre_joueur1)))
                                        (void))) '(border)))
(define bouton_player2_configue (make-object button% "Joueur 2" panel_droite_joueur2 
                                  (lambda (button event)
                                    (if (= player_configue 1)
                                        (begin
                                          (send player_message_configue set-label "Joueur 2")
                                          (set! player_configue 2)
                                          (send dialog_rotation set-value (symbol->string touche_symbol_rotation_joueur2))
                                          (send dialog_gauche set-value (symbol->string touche_symbol_gauche_joueur2))
                                          (send dialog_droite set-value (symbol->string touche_symbol_droite_joueur2))
                                          (send dialog_descendre set-value (symbol->string touche_symbol_descendre_joueur2)))
                                        (void))) '(border)))
(send panel_gauche_joueur1 set-alignment 'center 'center)
(send panel_droite_joueur2 set-alignment 'center 'center)

;************** pour le cadre du bas
(define panel_cadre_des_touches (make-object horizontal-panel% panel_configue ))
(send panel_cadre_des_touches min-height 100)

(define panel_nom_affectation (make-object vertical-panel% panel_cadre_des_touches))
(define panel_message_rotation (make-object horizontal-panel% panel_nom_affectation))
(define button_rotation (make-object button% " Rotation :     " panel_message_rotation 
                           (lambda (button event) (void))))
;                             (if (= player_configue 1)
;                                 (begin
;                                   (set! touche_symbol_rotation_joueur1 (send touche_configue get-key-code))
;                                   (send dialog_rotation set-value (symbol->string touche_symbol_rotation_joueur1)))
;                                 (begin
;                                   (set! touche_symbol_rotation_joueur2 (send touche_configue get-key-code))
;                                   (send dialog_rotation set-value (symbol->string touche_symbol_rotation_joueur2)))))))
(send panel_message_rotation set-alignment 'left 'bottom)
(define panel_message_gauche (make-object horizontal-panel% panel_nom_affectation))
(define button_Gauche (make-object button% " Gauche :      " panel_message_gauche 
                         (lambda (button event) (void))))
;                             (if (= player_configue 1)
;                                 (begin
;                                   (set! touche_symbol_gauche_joueur1 (send touche_configue get-key-code))
;                                   (send dialog_gauche set-value (symbol->string touche_symbol_gauche_joueur1)))
;                                 (begin
;                                   (set! touche_symbol_gauche_joueur2 (send touche_configue get-key-code))
;                                   (send dialog_gauche set-value (symbol->string touche_symbol_gauche_joueur2)))))))
(send panel_message_gauche set-alignment 'left 'bottom)
(define panel_message_droite (make-object horizontal-panel% panel_nom_affectation))
(define button_Droite (make-object button% " Droite :         " panel_message_droite
                        (lambda (button event) (void))))
;                             (if (= player_configue 1)
;                                 (begin
;                                   (set! touche_symbol_droite_joueur1 (send touche_configue get-key-code))
;                                   (send dialog_droite set-value (symbol->string touche_symbol_droite_joueur1)))
;                                 (begin
;                                   (set! touche_symbol_droite_joueur2 (send touche_configue get-key-code))
;                                   (send dialog_droite set-value (symbol->string touche_symbol_droite_joueur2)))))))
(send panel_message_droite set-alignment 'left 'bottom)
(define panel_message_descendre (make-object horizontal-panel% panel_nom_affectation))
(define button_Descendre (make-object button% " Descendre : " panel_message_descendre
                           (lambda (button event) (void))))
;                             (if (= player_configue 1)
;                                 (begin
;                                   (set! touche_symbol_descendre_joueur1 (send touche_configue get-key-code))
;                                   (send dialog_descendre set-value (symbol->string touche_symbol_descendre_joueur1)))
;                                 (begin
;                                   (set! touche_symbol_descendre_joueur2 (send touche_configue get-key-code))
;                                   (send dialog_descendre set-value (symbol->string touche_symbol_descendre_joueur2)))))))
(send panel_message_descendre set-alignment 'left 'bottom)
(define panel_bouton_help_defaut_configue (make-object horizontal-panel% panel_nom_affectation))
(send panel_bouton_help_defaut_configue set-alignment 'left 'bottom)
(define panel_vide (make-object horizontal-panel% panel_nom_affectation))
(define player_message_configue (make-object message% " Joueur 1 " panel_vide null))
(send panel_vide set-alignment 'left 'bottom)

(define Panel_verti_config_player (make-object vertical-panel% panel_cadre_des_touches))
(define dialog_rotation (make-object text-field% "" Panel_verti_config_player
                          (lambda (but event) 'up) "up" '(single)))
(define dialog_gauche (make-object text-field% "" Panel_verti_config_player
                          (lambda (but event) 'up) "left" '(single)))
(define dialog_droite (make-object text-field% "" Panel_verti_config_player
                          (lambda (but event) 'up) "right" '(single)))
(define dialog_descendre (make-object text-field% "" Panel_verti_config_player
                          (lambda (but event) 'up) "down" '(single)))
(define bouton_ok (make-object button% " O K " Panel_verti_config_player
                        (lambda (but event) 
                          (send configuration show #f)
                          (sleep/yield 0.1)
                          (if (= mode 1)
                              (begin
                                (Mettre_que_des_blocs Table_tetris2)
                                (Affiche_tetris dc_joueur2 Table_tetris2)
                                (send dc_joueur2 draw-bitmap bitmap_Mode_1joueur 109 205))))
                          '(border)))

;(define menu_barre_config (make-object menu-bar% configuration))
;(define menu_configue (make-object menu% "options" menu_barre_config))
;(define menu_item_defaut (make-object menu-item% "Defaut" menu_configue
;                                 (lambda (but event) 
;                                   (if (= player_configue 1)
;                                       (begin
;                                         (send dialog_rotation set-value "up")
;                                         (set! touche_symbol_rotation_joueur1 'up)
;                                         (send dialog_gauche set-value "left")
;                                         (set! touche_symbol_gauche_joueur1 'left)
;                                         (send dialog_droite set-value "right")
;                                         (set! touche_symbol_droite_joueur1 'right)
;                                         (send dialog_descendre set-value "down")
;                                         (set! touche_symbol_descendre_joueur1 'down))
;                                       (begin
;                                         (send dialog_rotation set-value "z")
;                                         (set! touche_symbol_rotation_joueur2 'z)
;                                         (send dialog_gauche set-value "q")
;                                         (set! touche_symbol_gauche_joueur2 'd)
;                                         (send dialog_droite  set-value "d")
;                                         (set! touche_symbol_droite_joueur2 'q)
;                                         (send dialog_descendre set-value "s")
;                                         (set! touche_symbol_descendre_joueur2 's))))))
;(define menu_item_help_configue (make-object menu-item% "Help" menu_configue
;                               (lambda (but event) (void))))