; ________________________________________________________________________________________________________
;|****************                les constantes globales obligatoires              **********************|
;|________________________________________________________________________________________________________|
(define difficulte 6)  ; pour choisir le niveau de difficulte 1 .. 6

(define mode 2)        ; pour choisir le mode 1 ou 2 players

; ________________________________________________________________________________________________________
;|***********************     Fonction sur la vitesse des object en mode 1Player    **********************|
;|________________________________________________________________________________________________________|
(define vitesse1 0.1)
(define nouvelle_acceleration 0)

(define (accelere n)                ; acceleration de la vitesse en mode 1joueur et conservation de la ligne d'acceleration
  (cond ((> vitesse1 0.01) (set! vitesse1 (- vitesse1 0.01)))
        ((> vitesse1 0.001) (set! vitesse1 (- vitesse1 0.001)))
        ((> vitesse1 0.0001) (set! vitesse1 (- vitesse1 0.0001)))
        (else (void)))
  (set! nouvelle_acceleration n))

(define (init_vitesse)
  (set! vitesse1 0.1)
  (set! nouvelle_acceleration 0))

(define vitesse2 0.05)   ; pas de changement de vitesse, juste pour ralentir

; ________________________________________________________________________________________________________
;|*******************              Nombre de lignes et les Scores               **************************|
;|________________________________________________________________________________________________________|
(define nb_ligne1 0)         ; le nombre de lignes

(define (ecrire-nb_ligne1)  ; affichage le nombre de ligne
  (cond ((< nb_ligne1 10)  (send message_nb_ligne1 set-label (string-append "00" (number->string nb_ligne1))))
        ((< nb_ligne1 100)  (send message_nb_ligne1 set-label (string-append "0" (number->string nb_ligne1))))
        (else (send message_nb_ligne1 set-label (number->string nb_ligne1)))))

(define score_joueur1 0)   ; le nombre de pts

(define (ecrire-score_joueur1)
  (cond ((< score_joueur1 10)  (send message_nb_score1 set-label (string-append "000" (number->string score_joueur1))))
        ((< score_joueur1 100)  (send message_nb_score1 set-label (string-append "00" (number->string score_joueur1))))
        ((< score_joueur1 1000)  (send message_nb_score1 set-label (string-append "0" (number->string score_joueur1))))
        (else (send message_nb_score1 set-label (number->string score_joueur1)))))

(define (ajoute_score_et_ligne1 n)
  (begin
    (set! nb_ligne1 (+ nb_ligne1 n))
    (ecrire-nb_ligne1)
    (set! score_joueur1 (+ score_joueur1 (expt 2 n)))
    (ecrire-score_joueur1)))

(define nb_ligne2 0)

(define (ecrire-nb_ligne2)
  (cond ((< nb_ligne2 10)  (send message_nb_ligne2 set-label (string-append "00" (number->string nb_ligne2))))
        ((< nb_ligne2 100)  (send message_nb_ligne2 set-label (string-append "0" (number->string nb_ligne2))))
        (else (send message_nb_ligne2 set-label (number->string nb_ligne2)))))

(define score_joueur2 0)

(define (ecrire-score_joueur2)
  (cond ((< score_joueur2 10)  (send message_nb_score2 set-label (string-append "000" (number->string score_joueur2))))
        ((< score_joueur2 100)  (send message_nb_score2 set-label (string-append "00" (number->string score_joueur2))))
        ((< score_joueur2 1000)  (send message_nb_score2 set-label (string-append "0" (number->string score_joueur2))))
        (else (send message_nb_score2 set-label (number->string score_joueur2)))))

(define (ajoute_score_et_ligne2 n)
  (begin
    (set! nb_ligne2 (+ nb_ligne2 n))
    (ecrire-nb_ligne2)
    (set! score_joueur2 (+ score_joueur2 (expt 2 n)))
    (ecrire-score_joueur2)))

(define (score_ligne_init)
  (set! nb_ligne1 0)
  (set! nb_ligne2 0)
  (set! score_joueur1 0)
  (set! score_joueur2 0)
  (send message_nb_score1 set-label (string-append "000" (number->string score_joueur1)))
  (send message_nb_score2 set-label (string-append "000" (number->string score_joueur2)))
  (send message_nb_ligne1 set-label (string-append "00" (number->string nb_ligne1)))
  (send message_nb_ligne2 set-label (string-append "00" (number->string nb_ligne2))))
; _____________________________________________________________________________________________________
;|*******************                   Fin du tetris                 *********************************|
;|_____________________________________________________________________________________________________|
(define (fin_tetris? table)  ; fin du tetris
  (define (aux vec col)
    (if (> col 10)
        #f
        (or (vector-ref vec col)
            (aux vec (add1 col)))))
  (aux (vector-ref table 15) 0))