(define T #(#(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #t #t #t #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #t #t #t #f #f #f #f)
            #(#f #f #f #f #t #t #t #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #t #t #t #t #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)
            #(#f #f #f #f #f #f #f #f #f #f #f)))

(define T2 #(#(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(1 1 1 1 1 1 1 1 1 1 1)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)
             #(0 0 0 0 0 0 0 0 0 0 0)))

(define (subtract1_colonne L)
  (let ((new_L '()))
    (do ((i L (cdr i)))
      ((null? i) (reverse new_L))
      (set! new_L (cons (list (sub1 (caar i)) (cadar i)) new_L)))))

(define (add1_colonne L)
  (let ((new_L '()))
    (do ((i L (cdr i)))
      ((null? i) (reverse new_L))
      (set! new_L (cons (list (add1 (caar i)) (cadar i)) new_L)))))

(define (subtract1_ligne L)
  (define (iter L acc)
    (if (null? L)
        (reverse acc)
        (iter (cdr L) (cons (list (caar L) (sub1 (cadar L))) acc))))
  (iter L '()))

(define (add1_ligne L)
  (let ((new_L '()))
    (do ((i L (cdr i)))
      ((null? i) (reverse new_L))
      (set! new_L (cons (list (caar i) (add1 (cadar i))) new_L)))))

(define (afficheT2)
  (define (iter n)
    (if (zero? n)
        (printf "~a~n" (vector-ref T2 n))
        (begin
          (printf "~a~n" (vector-ref T2 n))
          (iter (sub1 n)))))
  (iter 15))
; __________________________________________________________________________________________________
;|********************                La classe object barre                  **********************|
;|__________________________________________________________________________________________________|

(define (barre%)
  (define (Evaluer_barre_Vertical pos)
    (define (iter pos comp col)
      (if (null? pos)
          '()
          (cons (list col (+ comp (cadar pos))) (iter (cdr pos) (add1 comp) col))))
    (iter pos 0 (caar pos)))
  (define (Evaluer_barre_Horizontal pos)
    (define (iter pos comp ligne)
      (if (null? pos)
          '()
          (cons (list (+ comp (caar pos)) ligne) (iter (cdr pos) (add1 comp) ligne))))
    (let ((sans-permut (iter pos -1 (cadar pos))))
      (cons (cadr sans-permut) (cons (car sans-permut) (cddr sans-permut)))))
  (define (rotation_barre? L tab verti?)
    (if verti?
        (and (and (< (caar L) 9) (> (caar L) 0))
             (not (vector-ref (vector-ref tab (cadar L)) (- (caar L) 1)))
             (not (vector-ref (vector-ref tab (cadar L)) (+ (caar L) 1)))
             (not (vector-ref (vector-ref tab (cadar L)) (+ (caar L) 2))))
        (and (not (vector-ref (vector-ref tab (+ (cadar L) 1)) (caar L)))
             (not (vector-ref (vector-ref tab (+ (cadar L) 2)) (caar L)))
             (not (vector-ref (vector-ref tab (+ (cadar L) 3)) (caar L))))))
  (define (Descendre_barre? L table verti?)
    (and (not (zero? (cadar L)))
         (if verti?
             (not (vector-ref (vector-ref table (sub1 (cadar L))) (caar L)))
             (and (not (vector-ref (vector-ref table (sub1 (cadar L))) (caar L)))
                  (not (vector-ref (vector-ref table (sub1 (cadar L))) (caar (cdr L))))
                  (not (vector-ref (vector-ref table (sub1 (cadar L))) (caar (cddr L))))
                  (not (vector-ref (vector-ref table (sub1 (cadar L))) (caar (cdddr L))))))))
  (define (Translation_Gauche_verti? L table)
    (and (not (equal? (caar L) 0))
         (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
         (not (vector-ref (vector-ref table (+ (cadar L) 1)) (- (caar L) 1)))
         (not (vector-ref (vector-ref table (+ (cadar L) 2)) (- (caar L) 1)))
         (not (vector-ref (vector-ref table (+ (cadar L) 3)) (- (caar L) 1)))))
  (define (Translation_Gauche_horiz? L table)
    (and (> (caadr L) 0)
         (not (vector-ref (vector-ref table (cadar L)) (sub1 (caadr L))))))
  (define (Translation_Droite_verti? L table)
    (and (not (equal? (caar L) 10))
         (not (vector-ref (vector-ref table (cadar L)) (+ (caar L) 1)))
         (not (vector-ref (vector-ref table (+ (cadar L) 1)) (+ (caar L) 1)))
         (not (vector-ref (vector-ref table (+ (cadar L) 2)) (+ (caar L) 1)))
         (not (vector-ref (vector-ref table (+ (cadar L) 3)) (+ (caar L) 1)))))
  (define (Translation_Droite_horiz? L table)
    (if (< (caar (cdddr L)) 10)
        (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))
        #f))
  
  (let ((L '((5 15) (5 16) (5 17) (5 18)))
        (verti? true))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((fin) (not (descendre_barre? L (car args) verti?)))
        ((init) (set! L '((5 15) (5 16) (5 17) (5 18))))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Rotation) (if (Rotation_barre? L (car args) verti?)
                        (if verti?
                            (begin
                              (set! L (Evaluer_barre_Horizontal L))
                              (set! verti? false))
                            (begin
                              (set! L (Evaluer_barre_Vertical L))
                              (set! verti? true)))
                        (void)))
        ((Descendre) (if (descendre_barre? L (car args) verti?)
                         (set! L  (subtract1_ligne L))
                         (void)))
        ((Translation_Gauche) (if verti?
                                  (if  (Translation_Gauche_verti? L (car args))
                                       (set! L (subtract1_colonne L))
                                       (void))
                                  (if  (Translation_Gauche_horiz? L (car args))
                                       (set! L (subtract1_colonne L))
                                       (void))))
        ((Translation_Droite)  (if verti?
                                   (if  (Translation_Droite_verti? L (car args))
                                        (set! L (add1_colonne L))
                                        (void))
                                   (if  (Translation_Droite_Horiz? L (car args))
                                        (set! L (add1_colonne L))
                                        (void))))
        (else (error "operateur inconnu" selecteur))))
    this))