; __________________________________________________________________________________________________
;|********************                La classe object cube                   **********************|
;|__________________________________________________________________________________________________|

(define (cube%)
  (define (Translation_Gauche_cube? L table)
    (and (not (equal? (caar L) 0))
         (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
         (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1)))))
  (define (Translation_Droite_cube? L table)
    (and (not (equal? (caaddr L) 10))
         (not (vector-ref (vector-ref table (car (cdaddr L))) (+ (caaddr L) 1)))
         (not (vector-ref (vector-ref table (cadr (cadddr L))) (+ (car (cadddr L)) 1)))))
  (define (Descendre_le_cube? L table)
    (and (not (zero? (cadar L)))
         (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
         (not (vector-ref (vector-ref table (- (car (cdaddr L)) 1)) (caaddr L)))))
  
  (let ((L '((4 15) (4 16) (5 15) (5 16))))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((init) (set! L '((4 15) (4 16) (5 15) (5 16))))
        ((fin) (not (Descendre_le_cube? L (car args))))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Translation_gauche)  (if (Translation_Gauche_cube? L (car args))
                                   (set! L (subtract1_colonne L))
                                   (void)))
        ((Translation_Droite)  (if (Translation_Droite_cube? L (car args))
                                   (set! L (add1_colonne L))
                                   (void)))
        ((Rotation) (void))
        ((Descendre) (if (descendre_le_cube? L (car args))
                         (set! L (subtract1_ligne L))
                         (void)))
        (else (error " message inconnu " selecteur))))
    this))