; __________________________________________________________________________________________________
;|********************                La classe object Lgauche                **********************|
;|__________________________________________________________________________________________________|
(define (Lgauche%)                           
  (define (Translation_gauche? L table sens?)
    (case sens?
      ((1) (and (not (zero? (caar L)))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L))))))
      ((2) (and (not (zero? (caar L)))
                (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))))
      ((3) (and (not (zero? (caar (cdddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))))
      ((4) (and (not (zero? (caadr L)))
                (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))))
      (else error "pas possible")))
  (define (Translation_droite? L table sens?)
    (case sens?
      ((1) (and (not (= (caar (cdddr L)) 10))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))))
      ((2) (and (not (= (caadr L) 10))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))))
      ((3) (and (not (= (caar L) 10))
                (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L))))))
      ((4) (and (not (= (caar L) 10))
                (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L))))
                (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caaddr L))))
                (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))))
      (else error "pas possible")))
  (define (Rotation_Lgauche? L table sens?)
    (case sens?
      ((1) (and (not (vector-ref (vector-ref table (+ (cadar L) 1)) (caadr L)))
                (not (vector-ref (vector-ref table (+ (cadar L) 1)) (+ (caar L) 1)))
                (not (vector-ref (vector-ref table (+ (cadar L) 1)) (+ (caar L) 2)))
                (not (vector-ref (vector-ref table (cadadr L)) (+ (caadr L) 1)))))
      ((2) (and (> (caar L) 0)
                (not (vector-ref (vector-ref table (+ (cadar L) 2)) (- (caar L) 1)))
                (not (vector-ref (vector-ref table (+ (cadar L) 1)) (- (caar L) 1)))
                (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
                (not (vector-ref (vector-ref table (+ (cadadr L) 1)) (caadr L)))))
      ((3) (and (> (cadar L) 0)
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (- (caar L) 1)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (- (caar L) 2)))
                (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1)))))
      ((4) (and (< (caar L) 9)
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
                (not (vector-ref (vector-ref table (cadar L)) (+ (caar L) 1)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (+ (caadr L) 1)))
                (not (vector-ref (vector-ref table (- (cadar L) 2)) (+ (caadr L) 1)))))))
  (define (Evaluer_Lgauche_sens1 L)
    (cons (list (caar L) (cadar L))
          (cons (list (caar L) (sub1 (cadar L)))
                (cons (list (add1 (caar L)) (cadar L))
                      (cons (list (+ (caar L) 2) (cadar L)) '())))))
  (define (Evaluer_Lgauche_sens2 L)
    (cons (list (caadr L) (cadadr L))
          (cons (list (add1 (caadr L)) (cadadr L))
                (cons (list (caadr L) (add1 (cadadr L)))
                      (cons (list (caadr L) (+ (cadadr L) 2)) '())))))
  (define (Evaluer_Lgauche_sens3 L)
    (cons (list (caadr L) (cadadr L))
          (cons (list (caadr L) (add1 (cadadr L)))
                (cons (list (sub1 (caadr L)) (cadadr L))
                      (cons (list (- (caadr L) 2) (cadadr L)) '())))))
  (define (Evaluer_Lgauche_sens4 L)
    (cons (list (caadr L) (cadadr L))
          (cons (list (sub1 (caadr L)) (cadadr L))
                (cons (list (caadr L) (sub1 (cadadr L)))
                      (cons (list (caadr L) (- (cadadr L) 2)) '())))))
  (define (Descendre_Lgauche? L table sens?)
    (case sens?
      ((1) (and (not (zero? (cadadr L)))
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
                (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))
                (not (vector-ref (vector-ref table (- (cadar (cddr L)) 1)) (caaddr L)))))
      ((2) (and (not (zero? (cadadr L)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))))
      ((3) (and (not (zero? (cadar L)))
                (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))
                (not (vector-ref (vector-ref table (- (cadar (cddr L)) 1)) (caaddr L)))))
      ((4) (and (not (zero? (cadar (cdddr L))))
                (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
                (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))))
      (else error "pas possible")))
  (let ((L  '((4 16) (4 15) (5 16) (6 16)))
        (sens 1))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((init) (set! L '((4 16) (4 15) (5 16) (6 16))))
        ((fin) (not (descendre_Lgauche? L (car args) sens)))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Translation_Gauche) (if (Translation_Gauche? L (car args) sens)
                                  (set! L (subtract1_colonne L))
                                  (void)))
        ((Translation_Droite) (if (Translation_Droite? L (car args) sens)
                                  (set! L (add1_colonne L))
                                  (void)))
        ((Rotation) (if (Rotation_Lgauche? L (car args) sens)
                        (case sens
                          ((1) (begin
                                 (set! L (Evaluer_Lgauche_sens2 L))
                                 (set! sens 2)))
                          ((2) (begin
                                 (set! L (Evaluer_Lgauche_sens3 L))
                                 (set! sens 3)))
                          ((3) (begin
                                 (set! L (Evaluer_Lgauche_sens4 L))
                                 (set! sens 4)))
                          ((4) (begin
                                 (set! L (Evaluer_Lgauche_sens1 L))
                                 (set! sens 1)))
                          (else error "pas possible"))
                        (void)))
        ((Descendre) (if (descendre_lgauche? L (car args) sens)
                         (set! L (subtract1_ligne L))
                         (void)))
        (else (error " message inconnu " selecteur))))
    this))