; __________________________________________________________________________________________________
;|********************                La classe object tgauche                **********************|
;|__________________________________________________________________________________________________|
(define (Tgauche%)
  (define (Translation_Gauche? L table verti?)
    (if (not verti?)
        (and (not (equal? (caadr L) 0))
             (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
             (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1))))
        (and (not (equal? (caadr L) 0))
             (not (vector-ref (vector-ref table (cadar (cddr L))) (- (caar (cddr L)) 1)))
             (not (vector-ref (vector-ref table (cadadr L)) (- (caadr L) 1)))
             (not (vector-ref (vector-ref table (cadr (cadddr L))) (- (car (cadddr L)) 1))))))
  (define (Translation_Droite? L table verti?)
    (if (not verti?)
        (and (not (equal? 10 (caaddr L)))
             (not (vector-ref (vector-ref table (car (cdaddr L))) (+ (caaddr L) 1)))
             (not (vector-ref (vector-ref table (cadr (cadddr L))) (+ (car (cadddr L)) 1))))
        (and (not (equal? 10 (caaddr L)))
             (not (vector-ref (vector-ref table (cadar L)) (+ (caar L) 1)))
             (not (vector-ref (vector-ref table (car (cdaddr L))) (+ (caaddr L) 1)))
             (not (vector-ref (vector-ref table (cadadr L)) (+ (caadr L) 1))))))
  (define (Rotation_Tgauche? L table verti?)
    (if verti?
        (and (Translation_droite? L table verti?)
             (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
             (not (vector-ref (vector-ref table (- (cadar L) 1)) (+ (caar L) 1))))
        (and (not (vector-ref (vector-ref table (cadar L)) (- (caar L) 1)))
             (not (vector-ref (vector-ref table (+ (cadar L) 2)) (caar L))))))
  (define (Evaluer_Tgauche_Horizontal L)
    (cons (list (caar L) (- (cadar L) 1))
          (cons (list (- (caar L) 1) (cadar L))
                (cons (list (+ (caar L) 1) (- (cadar L) 1))
                      (cons (list (caar L) (cadar L)) '())))))
  (define (Evaluer_Tgauche_Vertical L)
    (cons (list (+ (caar L) 1) (+ (cadr (caddr L)) 1))
          (cons (list (caar L) (cadar L))
                (cons (list (+ (caar L) 1) (+ (cadadr L) 1))
                      (cons (list (caar L) (+ (cadar L) 1)) '())))))
  (define (Descendre_Tgauche? L table verti?)
    (if (not verti?)
        (and (not (zero? (cadar L)))
             (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
             (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
             (not (vector-ref (vector-ref table (- (car (cdaddr L)) 1)) (caaddr L))))
        (and (not (zero? (cadadr L)))
             (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
             (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L))))))
  (let ((L '((5 15) (4 16) (6 15) (5 16)))
        (verti false))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((init) (set! L '((5 15) (4 16) (6 15) (5 16))))
        ((fin) (not (descendre_Tgauche? L (car args) verti)))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Translation_Gauche) (if (Translation_Gauche? L (car args) verti)
                                  (set! L (subtract1_colonne L))
                                  (void)))
        ((Translation_Droite) (if (Translation_Droite? L (car args) verti)
                                  (set! L (add1_colonne L))
                                  (void)))
        ((Rotation) (if (Rotation_Tgauche? L (car args) verti)
                        (if verti
                            (begin
                              (set! L (Evaluer_Tgauche_Horizontal L))
                              (set! verti false))
                            (begin
                              (set! L (Evaluer_Tgauche_Vertical L))
                              (set! verti true)))
                        (void)))
        ((Descendre) (if (descendre_tgauche? L (car args) verti)
                         (set! L (subtract1_ligne L))
                         (void)))
        (else (error " message inconnu " selecteur))))
    this))