; __________________________________________________________________________________________________
;|********************               La classe object triangle                **********************|
;|__________________________________________________________________________________________________|
(define (triangle%)
  (define (Translation_gauche? L table sens?)
    (case sens?
      ((1) (if (zero? (caar (cddr L)))
               #f
               (and (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caar (cddr L)))))
                    (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L)))))))
      ((2) (if (zero? (caadr L))
               #f
               (and (not (vector-ref (vector-ref table (cadadr L)) (sub1 (caadr L))))
                    (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caaddr L))))
                    (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L))))))))
      ((3) (if (zero? (caar (cdddr L)))
               #f
               (and (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L)))))
                    (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L)))))))
      ((4) (if (= (caar L) 0)
               #f
               (and (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L))))
                    (not (vector-ref (vector-ref table (cadar (cddr L))) (sub1 (caaddr L))))
                    (not (vector-ref (vector-ref table (cadar (cdddr L))) (sub1 (caar (cdddr L))))))))
      (else (error "pas possible" sens?))))
  
  (define (Translation_droite? L table sens?)
    (case sens?
      ((1) (if (= (caar (cdddr L)) 10)
               #f
               (and (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L)))))
                    (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L)))))))
      ((2) (if (= (caar L) 10)
               #f
               (and (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L))))
                    (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caaddr L))))
                    (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L))))))))
      ((3) (if (= (caar (cddr L)) 10)
                 #f
                 (and (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caar (cddr L)))))
                      (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L)))))))
      ((4) (if (= (caadr L) 10)
               #f
               (and (not (vector-ref (vector-ref table (cadadr L)) (add1 (caadr L))))
                    (not (vector-ref (vector-ref table (cadar (cddr L))) (add1 (caaddr L))))
                    (not (vector-ref (vector-ref table (cadar (cdddr L))) (add1 (caar (cdddr L))))))))
      (else (error "pas possible" sens?))))

  (define (Evaluer_Triangle_sens1 L)
    (cons (list (caar L) (cadar L))
          (cons (list (caar L) (add1 (cadar L)))
                (cons (list (sub1 (caar L)) (add1 (cadar L)))
                      (cons (list (add1 (caar L)) (add1 (cadar L))) '())))))
  (define (Evaluer_Triangle_sens2 L)
    (cons (list (caar L) (cadar L))
          (cons (list (sub1 (caar L)) (cadar L))
                (cons (list (sub1 (caar L)) (sub1 (cadar L)))
                      (cons (list (sub1 (caar L)) (add1 (cadar L))) '())))))
  (define (Evaluer_Triangle_sens3 L)
    (cons (list (caar L) (cadar L))
          (cons (list (caar L) (sub1 (cadar L)))
                (cons (list (add1 (caar L)) (sub1 (cadar L)))
                      (cons (list (sub1 (caar L)) (sub1 (cadar L))) '())))))
  (define (Evaluer_Triangle_sens4 L)
    (cons (list (caar L) (cadar L))
          (cons (list (add1 (caar L)) (cadar L))
                (cons (list (add1 (caar L)) (add1 (cadar L)))
                      (cons (list (add1 (caar L)) (sub1 (cadar L))) '())))))
  
  (define (Rotation? L table sens?)
    (case sens?
      ((1) (and (> (cadar L) 0)
                (not (vector-ref (vector-ref table (cadar L)) (sub1 (caar L))))
                (not (vector-ref (vector-ref table (sub1 (cadar L))) (sub1 (caar L))))))
      ((2) (and (< (caar L) 10)
                (not (vector-ref (vector-ref table (sub1 (cadar L))) (caar L)))
                (not (vector-ref (vector-ref table (sub1 (cadar L))) (add1 (caar L))))))
      ((3) (and (not (vector-ref (vector-ref table (cadar L)) (add1 (caar L))))
                (not (vector-ref (vector-ref table (add1 (cadar L))) (add1 (caar L))))))
      ((4) (and (> (caar L) 0)
                (not (vector-ref (vector-ref table (add1 (cadar L))) (caar L)))
                (not (vector-ref (vector-ref table (add1 (cadar L))) (sub1 (caar L))))))
      (else (error "pas possible" sens?))))
  
  (define (Descendre_Triangle? L table sens?)
    (case sens?
      ((1) (if (zero? (cadar L))
               #f
               (and (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                    (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))
                    (not (vector-ref (vector-ref table (- (car (cdaddr L)) 1)) (caaddr L))))))
      ((2) (if (zero? (cadar (cddr L)))
               #f
               (and (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                    (not (vector-ref (vector-ref table (- (cadar (cddr L)) 1)) (caar (cddr L)))))))
      ((3) (if (zero? (cadadr L))
               #f
               (and (not (vector-ref (vector-ref table (- (cadadr L) 1)) (caadr L)))
                    (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L))))
                    (not (vector-ref (vector-ref table (- (car (cdaddr L)) 1)) (caaddr L))))))
      ((4) (if (= (cadar L) 1)
               #f
               (and (not (vector-ref (vector-ref table (- (cadar L) 1)) (caar L)))
                    (not (vector-ref (vector-ref table (- (cadar (cdddr L)) 1)) (caar (cdddr L)))))))
      (else error "pas possible")))
  (let ((L '((5 15) (5 16) (4 16) (6 16)))
        (sens 1))
    (define (this selecteur . args)
      (case selecteur
        ((liste) L)
        ((init) (set! L '((5 15) (5 16) (4 16) (6 16))))
        ((fin) (not (descendre_triangle? L (car args) sens)))
        ((affiche_liste) (printf " ~a~n" L))
        ((grimpe) (set! L (add1_ligne L)))
        ((Translation_Gauche) (if (Translation_gauche? L (car args) sens)
                                  (set! L (subtract1_colonne L))
                                  (void)))
        ((Translation_Droite) (if (Translation_Droite? L (car args) sens)
                                  (set! L (add1_colonne L))
                                  (void)))
        ((Rotation)  (if (Rotation? L (car args) sens)
                         (case sens
                           ((1) (begin
                                  (set! L (Evaluer_Triangle_sens2 L))
                                  (set! sens 2)))
                           ((2) (begin
                                  (set! L (Evaluer_Triangle_sens3 L))
                                  (set! sens 3)))
                           ((3) (begin
                                  (set! L (Evaluer_Triangle_sens4 L))
                                  (set! sens 4)))
                           ((4) (begin
                                  (set! L (Evaluer_Triangle_sens1 L))
                                  (set! sens 1)))
                           (else error "pas possible"))
                         (void)))
        ((Descendre)  (if (Descendre_triangle? L (car args) sens)
                          (set! L (subtract1_ligne L))
                          (void)))
        (else (error " message inconnu " selecteur))))
    this))