; _____________________________________________________________________________________________________
;|*******************           Modification sur les objets           *********************************|
;|_____________________________________________________________________________________________________|
(define (demande_objet1)
  (case (car attente1)
    ((0) (barre%))
    ((1) (cube%))
    ((2) (tdroite%))
    ((3) (tgauche%))
    ((4) (triangle%))
    ((5) (lgauche%))
    ((6) (ldroite%))
    (else (error " mauvaise vision " (car attente1)))))

; _____________________________________________________________________________________________________
;|*******************             Execution d'une touche              *********************************|
;|_____________________________________________________________________________________________________|
(define (execution_touches obj Mvt table dc)
  (case Mvt
    ((up) (begin
            (effacer (obj 'liste 1) Table)
            (obj 'rotation Table_tetris1 1)
            (ecrire (obj 'liste 1) Table)
            (affiche_tetris dc Table)))
    ((right) (begin
               (effacer (obj 'liste 1) Table)
               (obj 'translation_droite Table 1)
               (ecrire (obj 'liste 1) Table)
               (affiche_tetris dc Table)))
    ((down) (begin
              (if (obj 'fin Table 1)
                  (void)
                  (begin
                    (effacer (obj 'liste 1) Table)
                    (obj 'Descendre Table 1)
                    (ecrire (obj 'liste 1) Table)
                    (affiche_tetris dc Table)))))
    ((left) (begin
              (effacer (obj 'liste 1) Table)
              (obj 'translation_gauche Table 1)
              (ecrire (obj 'liste 1) Table)
              (affiche_tetris dc Table)))
    (else (void))))
; _____________________________________________________________________________________________________
;|*******************             Execution du jeu 1 player           *********************************|
;|_____________________________________________________________________________________________________|
(define (Lancer_1Player dc_vision dc table)
  (define (finir obj n)
    (send touche set-key-code #\null)
    (if  (and (= n 3) (not (obj 'fin table)))
         (begin
           (execution_touches obj 'down table dc)
           (finir obj 0))
          (begin
            (sleep/yield vitesse1)
            (let ((tuch (send touche get-key-code)))
              (if (and (or (equal? tuch 'down) (= n 3)) (obj 'fin table))
                  (begin
                    (obj 'init 1)
                    (Simplifier_1player table 1)
                    (if (and (zero? (modulo (add1 nb_ligne1) 10))
                             (> nb_ligne1 nouvelle_acceleration))
                            (accelere nb_ligne1))
                    (Lancer_1Player dc_vision dc table))
                  (begin
                    (execution_touches obj (send touche get-key-code) table dc)
                    (finir obj (add1 n))))))))
  (let ((pl (demande_objet1)))
    (if (pl 'fin table)
        (begin
          (init_vitesse)
          (send dc draw-bitmap bitmap_Game_over 89 205))
        (if (fin_tetris? table)
            (begin
              (init_vitesse)
              (send dc draw-bitmap bitmap_Game_over 89 205))
            (begin
              (Mettre_dans_vision1 dc_vision)
              (finir pl 0))))))