(define fenetre_loading (make-object frame% "Loading games" #f 260 40 400 400 '(no-system-menu)))
(define canvas_loading (make-object canvas% fenetre_loading '(border)))
(define dc_loading (send canvas_loading get-dc))

(define $green-brush (make-object brush% "green" 'solid))
(send dc_loading set-brush $green-brush)

(define (lance_loading_barre)
  (let ((x 0))
    (define (this . msg)
      (case (car msg)
        ((look) (send fenetre_loading show #t))
        ((end) (send fenetre_loading show #f))
        ((augmente) (begin
                      (set! x (+ x 16))
                      (send dc_loading draw-rectangle 0 0 x 11)))))
    this))

(define barre_load (lance_loading_barre))


; _____________________________________________________________________________________________________
;|******************    lecture des fichiers annexes et des objets tetris     *************************|
;|_____________________________________________________________________________________________________|        
(barre_load 'look)

(load (build-path "blocs" "barre.scm"))
(barre_load 'augmente)
(load (build-path "blocs" "cube.scm"))
(barre_load 'augmente)
(load (build-path "blocs" "Tgauche.scm"))
(barre_load 'augmente)
(load (build-path "blocs" "Tdroite.scm"))
(barre_load 'augmente)
(load (build-path "blocs" "triangle.scm"))
(barre_load 'augmente)
(load (build-path "blocs" "Ldroite.scm"))
(barre_load 'augmente)
(load (build-path "blocs" "Lgauche.scm"))
(barre_load 'augmente)
(load (build-path "support" "structure_de_donnes.scm"))
(barre_load 'augmente)
(load (build-path "data" "functions_table.scm"))
(barre_load 'augmente)
(load (build-path "data" "functions_visions.scm"))
(barre_load 'augmente)
(load (build-path "support" "ressources.scm"))
(barre_load 'augmente)
(load (build-path "support" "constantes.scm"))
(barre_load 'augmente)
(load (build-path "data" "1player.scm"))
(barre_load 'augmente)
(load (build-path "data" "2player.scm"))
(barre_load 'augmente)
(load (build-path "options" "difficults.scm"))
(barre_load 'augmente)
(load (build-path "options" "configuration.scm"))
(barre_load 'augmente)
(load (build-path "options" "motifs.scm"))
(load (build-path "options" "a_propos_de.scm"))

(barre_load 'end)
