(require-library "graphics.ss" "graphics" )

(open-graphics)

(load "loading.scm")

; fonctions fournies par Eric Coureux deug mi2 2000/2001
;_______________________________________________________________________________________________________________________
;|***************          Definition de la classe my_canvas% pour les venements claviers           *******************|
;|______________________________________________________________________________________________________________________|
(define my_canvas% (class canvas% (frame_essai style)
                     (inherit get-dc)
                     (override
                       [on-char
                        (lambda (event)
                          (send touche set-key-code (send event get-key-code)))])
                     (sequence (super-init frame_essai style))))

(define (Permettre_clavier)
  (send Canvas_joueur1 focus)
  (send Canvas_joueur1 on-char touche))

(define touche (make-object key-event%))

;_______________________________________________________________________________________________________________________
;|************************************** Les Fenetres Principale *******************************************************|
;|______________________________________________________________________________________________________________________|
(define fenetre_principale (make-object frame% "tetris 2 Palyer" #f 900 600 50 50 null))
(define Panel_de_tetris (make-object vertical-panel% fenetre_principale '(border)))

;_______________________________________________________________________________________________________________________
;|******************************** Fenetre avec les blocs futurs *******************************************************|
;|______________________________________________________________________________________________________________________|
(define Vision_Joueurs (make-object horizontal-panel% Panel_de_tetris))
(send Vision_joueurs min-height 80) ; hauteur de la barre des visions
(send Vision_joueurs border 10)

(define Panel_vision_joueur1 (make-object panel% Vision_joueurs ))
(send Panel_vision_joueur1 min-width 440)
(define Panel_vision_joueur2 (make-object panel% Vision_joueurs ))
(send Panel_vision_joueur2 min-width 440)

(define Canvas_vision_joueur1 (make-object canvas% Panel_vision_joueur1 '(border)))
(send Canvas_vision_joueur1 min-client-height 70)
(send Canvas_vision_joueur1 min-client-width 130)
(send Canvas_vision_joueur1 horiz-margin 115 )
(define dc_vision_joueur1 (send Canvas_vision_joueur1 get-dc))

(define Canvas_vision_joueur2 (make-object canvas% Panel_vision_joueur2 '(border)))
(send Canvas_vision_joueur2 min-client-height 70)
(send Canvas_vision_joueur2 min-client-width 130)
(send Canvas_vision_joueur2 horiz-margin 155)
(define dc_vision_joueur2 (send Canvas_vision_joueur2 get-dc))
 
;_______________________________________________________________________________________________________________________
;|************************************* Les Fenetres des jeux *******************************************************|
;|______________________________________________________________________________________________________________________|
(define Panel_de_jeu (make-object horizontal-panel% Panel_de_tetris))
(send Panel_de_jeu min-height 520)  ; hauteur de la zone du jeu
(send Panel_de_jeu border 15)

;--------------------- Zone d'ecrane Player 1 -----------------------------------
(define Panel_tetris_joueur1 (make-object panel% Panel_de_jeu ))
(send Panel_tetris_joueur1 min-width 363)
(send Panel_tetris_joueur1 min-height 495)
(define Canvas_joueur1 (make-object my_canvas% Panel_tetris_joueur1 '(border)))
(send Canvas_joueur1 min-client-width 363)
(send Canvas_joueur1 min-client-height 495)
(define dc_joueur1 (send Canvas_joueur1 get-dc))

;--------------------- Zone de Score et bouton ----------------------------------
(define Panel_bouton_&_score (make-object vertical-panel% Panel_de_jeu))
(send Panel_bouton_&_score min-width 110)

(define Panel_score_lignes_joueur1 (make-object Vertical-panel% Panel_bouton_&_score ))
(define message_joueur1 (make-object message% "Joueur1: " Panel_score_lignes_joueur1))
(define panel_ligne_joueur1 (make-object horizontal-panel% panel_score_lignes_joueur1))
(define ligne_j1 (make-object message% "Lignes : " panel_ligne_joueur1))
(define message_nb_ligne1 (make-object message% "000" panel_ligne_joueur1))
(define panel_score_joueur1 (make-object horizontal-panel% panel_score_lignes_joueur1))
(define score_j1 (make-object message% "Score : " panel_score_joueur1))
(define message_nb_score1 (make-object message% "0000" panel_score_joueur1))
(send Panel_score_lignes_joueur1 set-alignment 'center 'top)

(define Panel_score_lignes_joueur2 (make-object Vertical-panel% Panel_bouton_&_score ))
(define message_joueur2 (make-object message% "Joueur2: " Panel_score_lignes_joueur2))
(define panel_ligne_joueur2 (make-object horizontal-panel% panel_score_lignes_joueur2))
(define ligne_j2 (make-object message% "Lignes : " panel_ligne_joueur2))
(define message_nb_ligne2 (make-object message% "000" panel_ligne_joueur2))
(define panel_score_joueur2 (make-object horizontal-panel% panel_score_lignes_joueur2))
(define score_j2 (make-object message% "Score : " panel_score_joueur2))
(define message_nb_score2 (make-object message% "0000" panel_score_joueur2))
(send Panel_score_lignes_joueur2 set-alignment 'center 'top)

(define Panel_bouton_start (make-object panel% Panel_bouton_&_score ))
(send Panel_bouton_start min-height 200)
(define Go (make-object bitmap% adresse_start 'bmp))
(define Start_bouton (make-object button% Go Panel_bouton_start 
                       (lambda (botton events)
                         (if (not (send menu_bar is-enabled?))
                             (void)
                             (begin
                               (send Menu_bar enable #f)
                               (permettre_clavier)
                               (if (= mode 1)
                                   (Lancer_1Player  dc_vision_joueur1  dc_joueur1  Table_tetris1)
                                   (Lancer_2Player dc_vision_joueur2 dc_joueur2 Table_tetris2 dc_vision_joueur1 dc_joueur1 Table_tetris1))
                               (send Menu_bar enable #t)))) '(border)))
(send Start_bouton horiz-margin 25)
(send Start_bouton vert-margin 50)

;--------------------- Zone d'ecran Player 2 ------------------------------------
(define Panel_tetris_joueur2 (make-object panel% Panel_de_jeu ))
(send Panel_tetris_joueur2 min-width 363)
(send Panel_tetris_joueur2 min-height 495)
(define Canvas_joueur2 (make-object my_canvas% Panel_tetris_joueur2 '(border)))
(send Canvas_joueur2 min-client-width 363)
(send Canvas_joueur2 min-client-height 495)
(define dc_joueur2 (send Canvas_joueur2 get-dc))

;______________________________________________________________________________________________________________________
;|***************************************** Les "Menu" ****************************************************************|
;|_____________________________________________________________________________________________________________________|
(define Menu_bar (make-object menu-bar% fenetre_principale))

(define Menu_menu (make-object menu% "Menu"  Menu_bar #f))
(define joueur1 (make-object menu-item% "Mode 1 Joueur" Menu_menu
                  (lambda (botton events)
                    (send dc_joueur1 clear)
                    (send dc_joueur2 clear)
                    (send dc_vision_joueur1 clear)
                    (send dc_vision_joueur2 clear)
                    (set! mode 1)
                    (score_ligne_init)
                    (Mettre_que_des_blocs Table_tetris2)
                    (Affiche_tetris dc_joueur2 Table_tetris2)
                    (send dc_joueur2 draw-bitmap bitmap_Mode_1joueur 109 205)
                    (Mettre_a_Zero_les_Tables Table_tetris1 Table_tetris2))
                    #f #f))
(define joueur2 (make-object menu-item% "Mode 2 Joueurs" Menu_menu
                  (lambda (botton events)
                    (send dc_joueur1 clear)
                    (send dc_joueur2 clear)
                    (send dc_vision_joueur1 clear)
                    (send dc_vision_joueur2 clear)
                    (set! mode 2)
                    (score_ligne_init)
                    (Mettre_a_Zero_les_Tables Table_tetris1 Table_tetris2))
                  #f #f))

(define Menu_Options (make-object menu% "Options" Menu_bar #f))
(define Menu_config (make-object menu-item% "Config" Menu_Options 
                      (lambda (menu event)
                        (send dc_joueur1 clear)
                        (if (= mode 2)
                            (send dc_joueur2 clear))
                        (send dc_vision_joueur1 clear)
                        (send dc_vision_joueur2 clear)
                        (send configuration show #t)) #f #f))
(define menu_difficult (make-object menu-item% "Niveaux" Menu_Options
                         (lambda (Menu event)
                           (send dc_joueur1 clear)
                           (if (= mode 2)
                               (send dc_joueur2 clear))
                           (send dc_vision_joueur1 clear)
                           (send dc_vision_joueur2 clear)
                           (send difficult show #t)) #f #f))
(define menu_type_boite (make-object menu-item% "Motif" Menu_Options 
                          (lambda (menu event)
                            (send dc_joueur1 clear)
                            (if (= mode 2)
                                (send dc_joueur2 clear))
                            (send dc_vision_joueur1 clear)
                            (send dc_vision_joueur2 clear)
                            (send fenetre_like_motifs show #t)) #f #f))
(define Menu_A_propos_de (make-object menu-item% "A propos de" Menu_Options
                           (lambda (menu event)
                             (send dc_joueur1 clear)
                             (if (= mode 2)
                                 (send dc_joueur2 clear))
                             (send dc_vision_joueur1 clear)
                             (send dc_vision_joueur2 clear)
                             (lance_a_propos_de)) #f #f))


(send fenetre_principale set-alignment 'left 'top)


(send fenetre_principale show #t)